import java.io.*;
import java.awt.*;
import java.math.*;

public class Engine extends Frame
{
  final int Maxx = 500;
  final int Maxy = 500;
  canvas can = new canvas(Maxx,Maxy);

	static public void main(String args[])
	{
		(new Engine()).setVisible(true);
	}

	public Engine()
	{
		setLayout(null);
		setSize(Maxx,Maxy);
		setVisible(false);
		setTitle("3D engine");
		setResizable(true);
		Okno eventokno = new Okno();
		this.addWindowListener(eventokno);
		Kompon eventkomp = new Kompon();
		this.addComponentListener(eventkomp);
    this.add(can);
	}

	class Kompon extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == Engine.this) {
        Dimension d;
        d = getSize();
        can.setSize(d);
      }
		}
	}

	class Okno extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Engine.this) {
        dispose();
		    setVisible(false);
    		System.exit(0);
      }
		}
	}

  class canvas extends Canvas
  {
    vektor u, v;
    bod B;
    float d;

    final int POC = 200;
    final int stredx = 320;
    final int stredy = 200;

    bod[] A = new bod[POC];
    bod P;
    float alfa = 0, beta = 0;
    float t = 0, s = 0;
    int i = 0, j = 0;
    prumet prume;

    public canvas(int mx, int my)
    {
      setSize(mx,my);
      setVisible(true);
      u = new vektor();
      v = new vektor();
      B = new bod();
      P = new bod();
      prume = new prumet();

      u.x = 60; u.y = 0; u.z = 0;
      v.x = 0; v.y = 0; v.z = 60;
      B.x = -500; B.y = 0; B.z = 0;
      d = 1000;

      for (i = 0; i<POC; i++) {
/*
        A[i].x = cos(t)*sqrt(100*100-(100-t)*(100-t));
        A[i].y = sin(t)*sqrt(100*100-(100-t)*(100-t));
        A[i].z = t-100;
        t = t + 0.05;

        A[i].x = cos(t)*100;
        A[i].z = sin(t)*100;
        A[i].y = t*10-50;
        t = t + 0.02;
*/
        A[i].x = t*500;
        A[i].z = -500;
        A[i].y = s*500;
        t += 0.1;
        j ++;
        if (j>10) {
    	    j = 0;
          t = 0;
        	s += 0.1;
        }
      }

    }

    public void putpixel(int x, int y, int b)
    {
      Graphics g = this.getGraphics();
      Color c;
      c = new Color(b);
      g.setColor(c);
      g.drawLine(x,y,x,y);
    }

    public void putpixel(float x, float y, int b)
    {
      Graphics g = this.getGraphics();
      Color c;
      c = new Color(b);
      g.setColor(c);
      g.drawLine((int)x,(int)y,(int)x,(int)y);
    }

    public void line(int x1, int y1, int x2, int y2, int b)
    {
      Graphics g = this.getGraphics();
      Color c;
      c = new Color(b);
      g.setColor(c);
      g.drawLine(x1,y1,x2,y2);
    }

    public boolean mouseMove(Event e, int x, int y)
    {
      alfa = (float)(x*0.001);
      u.x = (float)Math.sin(alfa)*20;
      u.y = (float)Math.cos(alfa)*20;
      for (i = 0; i<POC; i++) {
        P = prume.calc(u, v, A[i], B, d);
        putpixel(P.x, P.y, 0);
      }
      return(true);
    }

  }
}

class vektor {
  float x, y, z;
}
class bod {
  float x, y, z;
}

class prumet {

  private float knas(vektor v, vektor u) {
    float k1 = 0, k2 = 0, k3 = 0, K = 0;

    if (u.x!=0) k1 = v.x/u.x;
    if (u.y!=0) k2 = v.y/u.y;
    if (u.z!=0) k3 = v.z/u.z;
    if (k1!=0) K = k1;
    if (k2!=0) K = k2;
    if (k3!=0) K = k3;
    return(K);
  }

  private int sgn(float h) {
    int pom = 0;
    if (h>0) pom = 1;
    if (h<0) pom = -1;
    return(pom);
  }

  public bod calc(vektor u, vektor v, bod A, bod B, float d)
  {
    bod P,C,D;
    P = new bod();  C = new bod();  D = new bod();
    vektor p, q, ac, bd, cd, n;
    p = new vektor();    q = new vektor();    ac = new vektor();
    bd = new vektor();   cd = new vektor();   n = new vektor();
    float t = 0;
    float X, Y, Z;
    bod pom;
    pom = new bod();

    if (d!=0) {
      t = (float)Math.sqrt(u.x*u.x + u.y*u.y + u.z*u.z);
      if (t!=0) t = d/t;
      P.x = B.x - u.x * t;    P.y = B.y - u.y * t;    P.z = B.z - u.z * t;
      p.x = A.x - P.x;    p.y = A.y - P.y;    p.z = A.z - P.z;
    }
    if (d==0) p = u;
    t = (u.x*(B.x-A.x) + u.y*(B.y-A.y) + u.z*(B.z-A.z))/(u.x*p.x + u.y*p.y + u.z*p.z);
    C.x = A.x + p.x*t;  C.y = A.y + p.y*t;  C.z = A.z + p.z*t;
    if (d!=0) {
      p.x = C.x - P.x;    p.y = C.y - P.y;    p.z = C.z - P.z;
    }
    q.x = u.y*v.z - u.z*v.y;  q.y = u.z*v.x - u.x*v.z;  q.z = u.x*v.y - u.y*v.x;
    t = (q.x*(B.x-C.x) + q.y*(B.y-C.y) + q.z*(B.z-C.z))/(q.x*q.x + q.y*q.y + q.z*q.z);
    D.x = C.x + q.x*t;  D.y = C.y + q.y*t;  D.z = C.z + q.z*t;
    ac.x = A.x - C.x;  ac.y = A.y - C.y;  ac.z = A.z - C.z;
    bd.x = B.x - D.x;  bd.y = B.y - D.y;  bd.z = B.z - D.z;
    cd.x = C.x - D.x;  cd.y = C.y - D.y;  cd.z = C.z - D.z;
    n.x = C.x - D.x;  n.y = C.y - D.y;  n.z = C.z - D.z;
    X = (float)Math.sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
    pom.x = X*sgn(knas(cd, q));
    n.x = B.x - D.x;  n.y = B.y - D.y;  n.z = B.z - D.z;
    Y = (float)Math.sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
    pom.y = Y*sgn(knas(bd, v));
    n.x = C.x - A.x;  n.y = C.y - A.y;  n.z = C.z - A.z;
    Z = (float)Math.sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
    pom.z = Z*sgn(knas(ac, p));
    return(pom);
  }
}

/*
public class Krivky {
  void pix(int x,int y, int b) {

  }

  class vektor {
    float x, y, z;
  }
  class bod {
    float x, y, z;
  }

}



  char c = "/n";
  while(c.compareTo("q")!=0) {

    for (i=0; i<POC; i++) {
    	P = prumet.calc(u,v,A[i],B,d);
    	if (P.z>0) pix(P.x+stredx, P.y+stredy, 15);
    }

    while (!kbhit() & (out)) {
  	  mys.aktual();
    	if (mys.move()) out = 0;
    }
    c = '/n';
    if (kbhit()) c = getch();
    fullx = fullx + mys.get_x() - stredx;
    alfa = -fullx*0.005;
    beta = -(mys.get_y()-stredy)*0.008;
    mys.set_xy(stredx, mys.get_y());
    if (c=='i') {
    	B.x += cos(alfa)*10;
    	B.y += sin(alfa)*10;
    }
    if (c=='k') {
  	B.x -= cos(alfa)*10;
  	B.y -= sin(alfa)*10;
  }
  u.x = cos(alfa)*10;
  u.y = sin(alfa)*10;
  u.z = sin(beta)*10;
  if (c=='u') d = d + 10;
  if (c=='o') d = d - 10;
};
}


void main(void) {

struct time T, U;
int cas;



int out = 1;
tip fullx;
mouse mys;


initialize();
mys.set_off();

setcolor(15);
*/
